import skimage.io as io
import matplotlib.pyplot as plt
import numpy as np
import math

def blur(image, filter_size):
    n_row, n_col, colors = image.shape
    blurred_image = np.zeros( (n_row, n_col, colors), dtype=np.uint8)
    half_size=int(filter_size/2)
    for i in range(n_row):
        for j in range(n_col):
            # define the boundaries of window around (i,j)
            bot=max(0,i-half_size)
            top=min(i+half_size,n_row)
            left=max(0,j-half_size)
            right=min(n_col,j+half_size)
            
            # calculate average of RGB values in window
            blurred_image[i,j] = \
                image[bot:top, left:right, :].max(axis=(0,1))
            
    return blurred_image

image = io.imread("car.jpg")

blurred_image = blur(image,5)
plt.imshow(blurred_image)
plt.show()
io.imsave("car_blur5.jpg",blurred_image)

#blurred_image = blur(image,21)
#plt.imshow(blurred_image)
#plt.show()
#io.imsave("car_blur21.jpg",blurred_image)

#blurred_image = blur(image,101)
#plt.imshow(blurred_image)
#plt.show()
#io.imsave("car_blur101.jpg",blurred_image)


#from scipy import ndimage
#blurred_image = ndimage.uniform_filter(image, size=(101, 101, 1))
#plt.imshow(blurred_image)
#plt.show()
#io.imsave("car_blur101_uniform_filter.jpg",blurred_image)

