import skimage.io as io
import skimage.color as color
import matplotlib.pyplot as plt
from skimage.color import rgb2gray
import numpy as np
import math

image = io.imread("car.jpg")
n_row, n_col, colors = image.shape

# create a blank image
new_image = np.zeros( (n_row, n_col, 3), dtype=np.uint8)

for i in range(1,n_row-1):
    for j in range(1,n_col-1):
        for c in range(3):
            Lx = float(image[i-1,j,c])-float(image[i+1,j,c])
            Ly = float(image[i,j-1,c])-float(image[i,j+1,c])
            gradient = math.sqrt(Lx**2+Ly**2)
            new_image[i,j,c] = np.uint8(gradient)
        
plt.imshow(new_image)
plt.show()
