import skimage.io as io
import skimage.color as color
import matplotlib.pyplot as plt
from skimage.color import rgb2gray
import numpy as np
import math
from skimage import feature


def detect_edges(image):
    n_row, n_col, colors = image.shape
    edge_image = np.zeros( (n_row, n_col, 3), dtype=np.uint8)
    for i in range(1,n_row-1):
        for j in range(1,n_col-1):
            for c in range(3):
                Lx = float(image[i-1,j,c])-float(image[i+1,j,c])
                Ly = float(image[i,j-1,c])-float(image[i,j+1,c])
                gradient = math.sqrt(Lx**2+Ly**2)
                edge_image[i,j,c] = np.uint8(gradient)
    return edge_image

#image = io.imread("malaria.jpg")
image = io.imread("car.jpg")

edge_image = detect_edges(image)

io.imsave("car_edges.jpg",edge_image)


edge2_image = feature.canny(rgb2gray(image), sigma=5)
io.imsave("car_canny_edges.jpg",edge2_image)
