import skimage.io as io
import matplotlib.pyplot as plt
import numpy as np

def upsidedown_wrong1(image):
    n_row, n_col = image.shape[0:2]    
    for i in range(0,int(n_row/2)):
        for j in range(0,n_col):            
            image[i,j] = image[n_row-i-1,j]
    return image

def upsidedown_wrong2(image):
    n_row, n_col = image.shape[0:2]
    for i in range(0,int(n_row/2)):
        for j in range(0,n_col):
            t = image[i,j]
            image[i,j] = image[n_row-i-1,j]
            image[n_row-i-1, j] = t
    return image

def upsidedown_correct1(image):
    n_row, n_col = image.shape[0:2]
    for i in range(0,int(n_row/2)):
        for j in range(0,n_col):
            t = image[i,j].copy()
            image[i,j] = image[n_row-i-1,j]
            image[n_row-i-1, j] = t
    return image

def upsidedown_correct2(image):
    n_row, n_col = image.shape[0:2]
    for i in range(0,int(n_row/2)):
        for j in range(0,n_col):
            for c in range(3):
                t = image[i,j,c] # a float value
                image[i,j,c] = image[n_row-i-1,j,c]
                image[n_row-i-1, j, c] = t
    return image

def upsidedown_correct3(image):
    return image[::-1,:]
    # image[::-1,:] reverse rows
    # image[:,::-1] reverse columns


def upsidedown_correct4(image):
    return np.flip(image, 0) 
    # axis=0 flip vertically;
    # axis=1 flip horizontally

# read image into memory
image = upsidedown_wrong1(io.imread("upsidedown.jpg"))
io.imsave("upsidedown_upsidedown_wrong1.jpg", image)

image = upsidedown_wrong2(io.imread("upsidedown.jpg"))
io.imsave("upsidedown_upsidedown_wrong2.jpg", image)

image = upsidedown_correct1(io.imread("upsidedown.jpg"))
io.imsave("upsidedown_upsidedown_correct1.jpg", image)

image = upsidedown_correct2(io.imread("upsidedown.jpg"))
io.imsave("upsidedown_upsidedown_correct2.jpg", image)


#plt.imshow(upsidedown_correct2(io.imread("upsidedown.jpg")))
#plt.show()



